unit Unit1;
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtDlgs, StdCtrls, ExtCtrls, PythonEngine,
  PythonGUIInputOutput;

type
  TForm1 = class(TForm)
    Image1: TImage;
    OpenPictureDialog1: TOpenPictureDialog;
    Memo1: TMemo;
    PythonEngine1: TPythonEngine;
    Panel1: TPanel;
    Button2: TButton;
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses
  VarPyth,
  Math,
  jpeg;

{$R *.dfm}

function ImageToPyBytes(AGraphic: TGraphic): Variant;
var
  _stream: TMemoryStream;
  _bytes: PPyObject;
begin
  _stream := TMemoryStream.Create();
  try
    AGraphic.SaveToStream(_stream);
    _bytes := GetPythonEngine.PyBytes_FromStringAndSize(_stream.Memory,
      _stream.Size);
    Result := VarPythonCreate(_bytes);
    GetPythonEngine.Py_DECREF(_bytes);
  finally
    _stream.Free;
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  if OpenPictureDialog1.Execute then
    Image1.Picture.LoadFromFile(OpenPictureDialog1.FileName);
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  _im: Variant;
  _stream: TMemoryStream;
  _dib: Variant;
  pargs: PPyObject;
  presult: PPyObject;
  P: PAnsiChar;
  Len: NativeInt;
begin
  if (Image1.Picture.Graphic = nil) or Image1.Picture.Graphic.Empty then
    raise Exception.Create('You must first select an image');
  PythonEngine1.ExecStrings(Memo1.Lines);
  _im := MainModule.ProcessImage(ImageToPyBytes(Image1.Picture.Graphic));
  Image1.Picture.Bitmap.SetSize(Image1.Width, Image1.Height);
  _dib := Import('PIL.ImageWin').Dib(_im);
  Image1.Picture.Bitmap.SetSize(Image1.Height, Image1.Width);
  _dib.expose(NativeInt(Image1.Picture.Bitmap.Canvas.Handle));
end;

end.
